﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace FirstTest
{
    [TestClass]
    public class SumMethodTests
    {
        [TestMethod,Description("1+1+1 değerleri gönderildiğinde 3 sonucu alınmalı")]
        public void SumMethodTest_Paremters_Fill_Return_Three_Result()
        {
            var result = Sum(1, 1, 1);
            Assert.AreEqual(result, 3);
        }

        [TestMethod,Description("Parameterlerden 1 tanesi null gönderildiğinde -1 sonucu alınmalı.")]
        public void SumMethodTest_Paremters_No_Fill_Return_Zero_Result()
        {
            var result = Sum(null, null, null);
            Assert.AreEqual(result, -1);

            result = Sum(1, null, null);
            Assert.AreEqual(result, -1);

            result = Sum(1, 1, null);
            Assert.AreEqual(result, -1);
        }

        public int Sum(int? x, int? y, int? z)
        {
            if (!x.HasValue || !y.HasValue || !z.HasValue)
            {
                return -1;
            }

            return (x.Value + y.Value + z.Value) ;
        }
    }
}
